/*===================================
		Copyright Yakibomb
*///=================================

// Later in the bootup, the functions starting with "CBaseEntity_" are converted to extend from CBaseEntity class.

function CBaseEntity_AddVSCond(condition=0,duration=-1,provider=null) {
	if ( VSCONDS_IsCondNumInvalid(condition,this) ) return;
	condition = VSCONDS_ClampCondValue(condition);
	
	local ent_data_table = format("%s_%d", "VSCOND_TABLE", this.entindex());
	local initialized = true;
	
	VSCONDS_CondEntInit(this);
	
	if ( !( condition in ROOT[ent_data_table] ) )
		initialized = false;
	
//	local cond_name = VSCOND_COND_NAMES[condition];

	if ( provider && provider.IsValid() ) { }
	else provider = worldspawn;
	
	if ( duration < 0.0 )
		duration = -1;
	else
		duration = Time() + duration.tofloat();
	
	ROOT[ent_data_table][condition] <- duration;
	
	if ( !initialized ) {
		local condition_settings = VSCONDS_GetCondFunc(condition);
		condition_settings["constructor"](this,provider);
		condition_settings["AddCond"](this,provider);
	}

	return true;
}

function CBaseEntity_InVSCond(condition) {
	if ( VSCONDS_IsCondNumInvalid(condition,this) ) return;
	condition = VSCONDS_ClampCondValue(condition);
	
//	local cond_name = VSCOND_COND_NAMES[condition];
	local ent_data_table = format("%s_%d", "VSCOND_TABLE", this.entindex());
	if ( !( VSCOND_ENTS_UNDER_CONDS.find(ent_data_table) ) )
		return false;
	if ( !( condition in ROOT[ent_data_table] ) )
		return false;
	
	VSCONDS_CondEntInit(this)
	
	local duration = ROOT[ent_data_table][condition];
	
	if ( duration == -1 ) return true;
	
	return duration < Time() ? false : true
}

function CBaseEntity_RemoveVSCond(condition) {
	if ( VSCONDS_IsCondNumInvalid(condition,this) ) return;
	condition = VSCONDS_ClampCondValue(condition);
	
	local ent_data_table = format("%s_%d", "VSCOND_TABLE", this.entindex());
	
	VSCONDS_CondEntInit(this);
	
	if ( !( condition in ROOT[ent_data_table] ) )
		return false;
	
	local ent = this.entindex();
	local condition_settings = VSCONDS_GetCondFunc(condition);
	condition_settings["RemoveCond"](this, condition_settings.provider);
	
	VSCONDS_RemoveAttachmentEnt(ent,condition)
	
	if ( condition_settings.use_think_script == true ) {
		VSCONDS_RemoveThinkToCond(ent,condition);
	}
	
	if ( ROOT[ent_data_table].len() == 2 ) {
		if ( this in VSCOND_HIDDEN_WEARABLES ) {
			VSCOND_HIDDEN_WEARABLES[this].Kill();
			delete VSCOND_HIDDEN_WEARABLES[this];
		}
	}
	
	return true;
}

function CBaseEntity_GetVSCondDuration(condition) {
	if ( VSCONDS_IsCondNumInvalid(condition,this) ) return;
	condition = VSCONDS_ClampCondValue(condition);
	
	local ent_data_table = format("%s_%d", "VSCOND_TABLE", this.entindex());
	if ( !( VSCOND_ENTS_UNDER_CONDS.find(ent_data_table) ) )
		return 0.0;
	if ( !( condition in ROOT[ent_data_table] ) )
		return 0.0;
	
	local duration = ROOT[ent_data_table][condition];
	local time = Time();
	
	return  duration > time ? duration - time : 0.0;
}



/*===================================
		Copyright Yakibomb
*///=================================