/*===================================
		Copyright Yakibomb
*///=================================
function VSConds_Think_Validate_Entity(ent_data) {
	
	local ent_datatable = ROOT[ent_data];
	if ( ent_datatable.len() == 2 ) { }
	else {
		local ent = ent_datatable[VSCond_MAX_Conditions];
		local ent_validate = ent_datatable[VSCond_MAX_Conditions + 1];
		if ( !ent_validate || !ent_validate.IsValid() ) return true;
		if ( VSCONDS_IsEntValid(ent) == ent_validate ) return false;
	}
	
	return true;
}

function VSConds_Think_Delete(ent_data,ent_table_key) {
	local ent_index = split(ent_data.tostring(),"_");
	ent_index = ent_index[2].tointeger();
	
	VSCOND_ENTS_UNDER_CONDS.remove(VSCOND_ENTS_UNDER_CONDS.find(ent_data));
	delete ROOT[ent_data];
	VSCONDS_RemoveThinkToCond_ALL(ent_index);
	VSCONDS_RemoveAttachmentEnt_ALL(ent_index)
//	printl("DELETED " + ent_index);
}

function VSConds_Think() {
	if ( VSCOND_ENTS_UNDER_CONDS.len() <= 1 ) {
	//	printl("I sleep"); 
		return VSCond_Think_SleepTime;
	}
	//printl("I run");
	
	foreach( ent_table_key,ent_data in VSCOND_ENTS_UNDER_CONDS )
	{
	// Validates the entity against originally created entity
	// In this way we don't give conditions to entities that weren't intended to it
		if ( ent_data == null ) continue
		if ( VSConds_Think_Validate_Entity(ent_data) ) {
			VSConds_Think_Delete(ent_data,ent_table_key);
			break;
		}
		
	// Since we know the entity exists/IsValid, check duration and if target is dead/changed classes
		ent_data = ROOT[ent_data];
		local ent = ent_data[VSCond_MAX_Conditions];
		local time = Time();
		local ent_invalid = VSCONDS_IsEntDeadOrChanged(ent)
		
		foreach (condition,duration in ent_data ) {
			if ( condition >= VSCond_MAX_Conditions ) continue
			
			if ( ent_invalid ) {
				ent.RemoveVSCond(condition);
				delete ent_data[condition];
			}
			else if ( duration < 0 ) {
			}
			else if ( time >= duration ) {
				ent.RemoveVSCond(condition);
				delete ent_data[condition];
			}
		}
	}
	return VSCond_Think_RunTime;
}