/*===================================
		Copyright Yakibomb
*///=================================

/*===================================
- Params convention
	1)  Your condition's class name must start with "VS_COND_" for the compiler to pick it up.
		( You can name the .nut file anything, that's for your organization. )
	2)	Your condition's class name is converted into a constant with condition's ID number when compiled.
		Please use it (for example) like "handle.AddVSCond(VS_COND_EXAMPLE)"
		( No figuring out what numbers go with what condition necessary! )
	3)	Finally, to compile your custom conds, add them to the compile steps in "compiler.nut"
*///=================================

/*===================================
- Available variables to read from this class
- Writing to these variables in the class might cause undesired effects

	condition == condition's ID number,

	entity == entity handle with applied condition,
	provider == provider handle (worldspawn by default),

	entity_scope == Entity's scope,
	provider_scope == Provider's scope,
	
	use_think_script == reads `true` if Think() function available in extended class,
	think_ent == Condition's think script entity,
	think_ent_scope = think script entity's scope.

*//*===================================
- Extended functions in this class
- Write your code in these functions!
	Think()						//optional
	AddCond(entity,provider)	
	RemoveCond(entity,provider)
	
- These are here for easy access, might be unnecessary but hey they're here.
	PauseThink()	//Pauses think script to be started later
	UnpauseThink()	//Unpauses think script
	RemoveThink()	//Removes think script. Can be used within same think script.
	
*///===================================


// VS_COND_EXAMPLE is the name of the function, which gets converted into a number ID on compile.

// When you go to add the condition to an entity, call it with:
// ent.AddVSCond(VS_COND_EXAMPLE)

class VS_COND_EXAMPLE extends VSConds_Base	//must extend from VSConds_Base
{

//Place your code here for AddCond here
//This one prints all key values in chat
	function AddCond(entity,provider) {
		local color_RED = "\x07FF3F3F";
		ClientPrint(null,3, color_RED+" -> AddCond()");
		foreach (useable_var,prints in this)
			ClientPrint(null,3, useable_var + " | " + prints);
	}
	
//Put your optional think function here
//Creates a separate entity to think for your entity with condition
	function Think() {
		printl(think_ent + " is thinking!\n Condition ID: " + condition);	//`think_ent` is the handle of the thinking entity. Can also use `self`.
		return 0.33;
	}
	
//Place your code here for RemoveCond here
//This one prints all key values in chat
	function RemoveCond(entity,provider) {
		local color_RED = "\x07FF3F3F";
		ClientPrint(null,3, color_RED+" -> RemoveCond()");
		foreach (useable_var,prints in this)
			ClientPrint(null,3, useable_var + " | " + prints);
	}
}

//Polite reminder to make sure to add your scripts in "compiler.nut" so this compiles appropriately!